{$reference AForge.dll}
{$reference AForge.Controls.dll}
{$reference AForge.Video.dll}
{$reference AForge.Video.DirectShow.dll}
{$reference AForge.Imaging.dll}

uses
  System, System.Windows.Forms, AForge.Video, AForge.Video.DirectShow, AForge.Imaging.Filters;

//    (     )
const FrameWidth = 1280;
      FrameHeight = 720;

var
  MyForm: Form;
  Player: AForge.Controls.VideoSourcePlayer;
  videoSource: VideoCaptureDevice;

/// <summary>
///     AForge    
/// </summary>
/// <param name="sender"></param>
/// <param name="eventArgs"></param>
procedure ApplyFilterOnFrame(sender : object; eventArgs : NewFrameEventArgs);
begin
  //       
  var btmp : System.Drawing.Bitmap := eventArgs.frame;

  //   
  var filter : ChannelFiltering := new ChannelFiltering( );
  
  filter.Red   := new AForge.IntRange( 0, 255 );
  filter.Green := new AForge.IntRange( 256, 256 );
  filter.Blue  := new AForge.IntRange( 256, 256 );

  // 
  filter.ApplyInPlace(btmp);
end;

/// <summary>
///       ,  
/// </summary>
procedure ProcessVideoDevice(camIndex : integer := -1; camMode : integer := -1);
begin
  //    ( )
  var videoDevices := new FilterInfoCollection(FilterCategory.VideoInputDevice);
  
  if videoDevices.Count = 0 then 
    raise new ApplicationException(',    - ');
  
  //        
  if camIndex = -1 then
    begin
      writeln('   : ',videoDevices.Count);
      camIndex := 0;
      if videoDevices.Count>1 then 
        begin
          writeln('  :',videoDevices.Count);
          for var i:=0 to videoDevices.Count-1 do
            writeln('    ',i,' : ',videoDevices[i].Name);
          camIndex := ReadInteger('     :');
      
          if (camIndex<0) or (camIndex>=videoDevices.Count) then
            raise new ApplicationException('   !');
        end;
      if videoDevices.Count>1 then
        writeln('    ',camIndex)
      else
        writeln('    0 ( ,   )')
    end;
  
  videoSource := new VideoCaptureDevice(videoDevices[camIndex].MonikerString);
  //     -     !
  //   ,         
  
  if camMode = -1 then
    begin
      writeln('    (',videoDevices[camIndex].Name,'):');
      for var i:=0 to videoSource.VideoCapabilities.Count-1 do
        writeln(i, ' - ', videoSource.VideoCapabilities[i].FrameSize);
      
      //      
      camMode := ReadInteger('     :');
      if (camMode<0) or (camMode>=videoSource.VideoCapabilities.Count) then
        raise new ApplicationException('?   !');
        
      write('        ,  ');
      writeln('          ProcessVideoDevice');
      write(',       ProcessVideoDevice()  ');
      writeln('  ( 150)  ProcessVideoDevice(',camIndex,',',camMode,')');  
    end;
  
  //     
  videoSource.DesiredFrameSize := videoSource.VideoCapabilities[camMode].FrameSize;
  videoSource.DesiredFrameRate := videoSource.VideoCapabilities[camMode].FrameRate;
  
  //     ,   
  videoSource.NewFrame += ApplyFilterOnFrame;
  
  //       
  Player := AForge.Controls.VideoSourcePlayer.Create;
  Player.Width := videoSource.DesiredFrameSize.Width;
  Player.Height := videoSource.DesiredFrameSize.Height;
  Player.Top := 10;
  Player.Left := 10;
  MyForm.Height := Player.Height+60;
  MyForm.Width := Player.Width+37;
  
  //     ,     
  Player.VideoSource := new AsyncVideoSource(videoSource);
  MyForm.Controls.Add(Player);
  Player.Start();
end;

/// <summary>
///     
/// </summary>
procedure StopVideoDevice;
begin
  Player.Stop;
  videoSource.Stop;
  //videoSource.Stooop;
end;

/// <summary>
///       
/// </summary>
/// <param name="sender"></param>
/// <param name="args"></param>
procedure ReleaseCamera(sender: object; args: System.ComponentModel.CancelEventArgs);
begin
  StopVideoDevice;
end;

/// <summary>
///      () 
/// </summary>
procedure DefineForm;
begin
  MyForm := System.Windows.Forms.Form.Create;
  MyForm.Text := '  -';
  MyForm.Height := FrameHeight+60;
  MyForm.Width := FrameWidth+37;
  MyForm.Closing += ReleaseCamera;
end;

begin
  //   ,       
  DefineForm;  
  ProcessVideoDevice();
  Application.Run(MyForm);
end.